﻿ $(document).ready(function () {
        $("#dialog-confirm").dialog({
            autoOpen: false,
            modal: true,
            resizable: false,
            width: 500,
            height: 'auto',
        });

        $("#dialog-settings").dialog({
            autoOpen: false,
            modal: true,
            resizable: false,
            width: 'auto',
            height: 'auto',
            buttons: [
                {
                    text: Localization_Save,
                    click: function () {
                        $("#formBasicSettings").submit();
                    }
                },
                {
                    text: Localization_Close,
                    click: function () {
                        $("#dialog-settings").dialog("close");
                    }
                }
            ]
        });

        $("#formBasicSettings").submit(function (event) {
            $('#divUsageRequiredError').hide();

            if ($('input.js-category-usage:checked').length == 0) { //neni vybrano zadne pouziti
                $('#divUsageRequiredError').show();
                event.preventDefault(); //pro ajax nejede?
                return false; //ajax?
            }
        });

        $("#dialog-category-item").dialog({
            autoOpen: false,
            modal: true,
            resizable: false,
            width: 'auto',
            height: 'auto',
            buttons: [
                {
                    id: "categoryItemSaveButton",
                    text: Localization_Save,
                    click: function () {
                        $("#DialogCategoryItemName").closest("div").find(".valid-error").hide();
                        if ($("#DialogCategoryItemName").val() == "") {
                            $("#DialogCategoryItemName").closest(".form-group").find(".valid-error").show();
                        } else {
                            $("#formCategoryItem").submit();
                        }
                    }
                },
                {
                    text: Localization_Close,
                    click: function () {
                        $("#dialog-category-item").dialog("close");
                    }
                }
            ]
        });

        $(".deleteLink").click(function (e) {
            e.preventDefault();
            var targetUrl = $(this).attr("href");

            $("#dialog-confirm").dialog({
                buttons: [
                    {
                        text: Localization_Yes,
                        click: function() {
                            window.location.href = targetUrl;
                        }
                    },
                    {
                        text: Localization_No,
                        click: function() {
                            $(this).dialog("close");
                        }
                    }
                ]
            });

            $("#dialog-confirm").dialog("open");
        });

        $("#categoryItemTree").on("click", ".node .cursor_pointer", function () {
            if ($(this).hasClass("fa-minus-square-o")) {
                $(this).removeClass("fa-minus-square-o");
                $(this).addClass("fa-plus-square-o");
                $(this).closest(".node").find(".children").hide();
            } else {
                $(this).removeClass("fa-plus-square-o");
                $(this).addClass("fa-minus-square-o");
                $(this).closest(".node").find(".children").show();
            }
        });
    });

    function openDialogFolder(parent) {
        $("#dialog-category-item").dialog('option', 'title', $("#dialog-category-item").data('title-new-folder'));
        $("#categoryItemSaveButton").text(Localization_Create);
        $("#dialog-category-item").html("<div class='loading-32'></div>");
        $("#dialog-category-item").load(RQ_URL + "/Admin/Category/DialogCategory?isFolder=true&selectedParent=" + parent + "&categoryId=" + categoryId, function () {
            $(".colorSelector-input").each(function () {
                InitColorPicker($(this));
            });
            SearchableCombos();
            $("#dialog-category-item").dialog("close");
            $("#dialog-category-item").dialog("open");
        });
        $("#dialog-category-item").dialog("open");
    }

    function openDialogCategoryItem(parent) {
        $("#dialog-category-item").dialog('option', 'title', $("#dialog-category-item").data('title-new-category-item'));
        $("#categoryItemSaveButton").text(Localization_Create);
        $("#dialog-category-item").html("<div class='loading-32'></div>");
        $("#dialog-category-item").load(RQ_URL + "/Admin/Category/DialogCategory?isFolder=false&selectedParent=" + parent + "&categoryId=" + categoryId, function () {
            $(".colorSelector-input").each(function () {
                InitColorPicker($(this));
            });
            SearchableCombos();
            $("#dialog-category-item").dialog("close");
            $("#dialog-category-item").dialog("open");
        });
        $("#dialog-category-item").dialog("open");
    }

    function openDialogEditCategoryItem(id, isFolder) {
        if (isFolder == 1) {
            $("#dialog-category-item").dialog('option', 'title', $("#dialog-category-item").data('title-edit-folder'));
        } else {
            $("#dialog-category-item").dialog('option', 'title', $("#dialog-category-item").data('title-edit-category-item'));
        }
        $("#categoryItemSaveButton").text(Localization_Save);
        $("#dialog-category-item").html("<div class='loading-32'></div>");
        $("#dialog-category-item").load(RQ_URL + "/Admin/Category/DialogCategory?categoryId=" + categoryId + "&categoryItemId=" + id, function () {
            $(".colorSelector-input").each(function () {
                InitColorPicker($(this));
            });
            SearchableCombos();
            $("#dialog-category-item").dialog("close");
            $("#dialog-category-item").dialog("open");
        });
        $("#dialog-category-item").dialog("open");
    }

    function openDialogSettings() {
        $("#dialog-settings").dialog("open");
    }

    function OnFormSuccess() {
        $("#dialog-settings").dialog("close");
    }

    function OnFormCategoryItemComplete() {
        $("#dialog-category-item").dialog("close");
    }

    function changePosition(up, id) {
        $.ajax({
            url: RQ_URL + "/Admin/Category/ChangeCategoryItemPosition",
            type: "POST",
            data: JSON.stringify({
                up: up,
                id: id
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            error: function (error) { alert(error.responseText); },
            complete: function () {
                window.location.reload();
            }
        });
    }