﻿var CACHE_NAME = 'Requestor-messaging-cache-v1';
var urlsToCache = [
    '../favicon-96x96.png',
    '../app-badge-96x96.png',
];

self.addEventListener('install', function (event) {
    // Perform install steps
    event.waitUntil(
        caches.open(CACHE_NAME)
            .then(function (cache) {
                return cache.addAll(urlsToCache);
            })
    );
});

self.onnotificationclick = function (event) {
    function getUrlPathArray(str) {
        str = str.replace(/(^\?)/, '');
        var indexOfPathEnd = str.indexOf('?');
        if (indexOfPathEnd === -1)
            indexOfPathEnd = str.indexOf('#');

        return (indexOfPathEnd >= 0 ? str.substring(0, indexOfPathEnd) : str).split('/');
    }

    event.notification.close();
    console.log("FCM: process click from service worker");

    // This looks to see if the current is already open and focuses if it is
    event.waitUntil(clients.matchAll({ includeUncontrolled: true, type: "window" }).then(function (clientList) {
        for (var i = 0; i < clientList.length; i++) {
            var client = clientList[i];
            if ('focus' in client) {
                var clientUrlPathArray = getUrlPathArray(client.url);
                if (clientUrlPathArray.length > 1 && clientUrlPathArray[clientUrlPathArray.length - 1] === event.notification.data.ticketref) {
                    //client.navigate('../Tickets/Show/' + event.notification.data.ticketref);
                    console.log("FCM: focus from service worker");
                    return client.focus();
                }
            }
        }

        if (clients.openWindow) {
            var openWindowUrl = '../Tickets/Show/' + event.notification.data.ticketref;
            if (event.notification.data.ticketusermessageid)
                openWindowUrl += "#" + event.notification.data.ticketusermessageid

            console.log("FCM: open window from service worker");
            return clients.openWindow(openWindowUrl);
        }
    }));
};


// Give the service worker access to Firebase Messaging.
// Note that you can only use Firebase Messaging here, other Firebase libraries
// are not available in the service worker.
importScripts('firebase/firebase-app.js');
importScripts('firebase/firebase-messaging.js');

// Initialize the Firebase app in the service worker by passing in messagingSenderId.
firebase.initializeApp({
    'messagingSenderId': '528071331944'
});

// Retrieve an instance of Firebase Messaging so that it can handle background messages.
const messaging = firebase.messaging();
messaging.setBackgroundMessageHandler(function (payload) {
    // Customize notification here
    var notificationTitle = payload.data.ticketref;
    var notificationOptions = {
        body: payload.data.body,
        icon: urlsToCache[0],
        badge: urlsToCache[1],
        tag: payload.data.ticketref,
        data: {
            ticketref: payload.data.ticketref,
            ticketusermessageid: payload.data.ticketusermessageid
        }
    };

    return self.registration.showNotification(notificationTitle, notificationOptions);
});